# Common files
require 'osdn-client/api_client'
require 'osdn-client/api_error'
require 'osdn-client/version'
require 'osdn-client/configuration'

# Models
require 'osdn-client/models/simple_user'
require 'osdn-client/models/user'
require 'osdn-client/models/simple_group'
require 'osdn-client/models/group'
require 'osdn-client/models/group_tool_flags'
require 'osdn-client/models/simple_chamber'
require 'osdn-client/models/skill'
require 'osdn-client/models/news'
require 'osdn-client/models/package'
require 'osdn-client/models/release'
require 'osdn-client/models/rel_file'
require 'osdn-client/models/token'
require 'osdn-client/models/pong'

# APIs
require 'osdn-client/api/user_api'
require 'osdn-client/api/default_api'
require 'osdn-client/api/project_frs_api'
require 'osdn-client/api/test_api'
require 'osdn-client/api/project_api'
require 'osdn-client/api/project_news_api'

module OSDNClient
  class << self
    # Customize default settings for the SDK using block.
    #   OSDNClient.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end
