require 'date'

module OSDNClient
  class Group
    attr_accessor :id

    attr_accessor :name

    attr_accessor :display_name

    attr_accessor :last_update

    attr_accessor :description

    attr_accessor :description_html

    attr_accessor :start_date

    attr_accessor :license

    attr_accessor :license_other

    attr_accessor :url

    attr_accessor :homepage

    attr_accessor :logo_image

    attr_accessor :banner_image

    attr_accessor :thumbnail_image

    attr_accessor :tools

    attr_accessor :members

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'id' => :'id',
        
        :'name' => :'name',
        
        :'display_name' => :'display_name',
        
        :'last_update' => :'last_update',
        
        :'description' => :'description',
        
        :'description_html' => :'description_html',
        
        :'start_date' => :'start_date',
        
        :'license' => :'license',
        
        :'license_other' => :'license_other',
        
        :'url' => :'url',
        
        :'homepage' => :'homepage',
        
        :'logo_image' => :'logo_image',
        
        :'banner_image' => :'banner_image',
        
        :'thumbnail_image' => :'thumbnail_image',
        
        :'tools' => :'tools',
        
        :'members' => :'members'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'id' => :'Integer',
        :'name' => :'String',
        :'display_name' => :'String',
        :'last_update' => :'DateTime',
        :'description' => :'String',
        :'description_html' => :'String',
        :'start_date' => :'DateTime',
        :'license' => :'String',
        :'license_other' => :'String',
        :'url' => :'String',
        :'homepage' => :'String',
        :'logo_image' => :'String',
        :'banner_image' => :'String',
        :'thumbnail_image' => :'String',
        :'tools' => :'GroupToolFlags',
        :'members' => :'Array<SimpleUser>'
        
      }
    end

    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes[:'id']
        self.id = attributes[:'id']
      end
      
      if attributes[:'name']
        self.name = attributes[:'name']
      end
      
      if attributes[:'display_name']
        self.display_name = attributes[:'display_name']
      end
      
      if attributes[:'last_update']
        self.last_update = attributes[:'last_update']
      end
      
      if attributes[:'description']
        self.description = attributes[:'description']
      end
      
      if attributes[:'description_html']
        self.description_html = attributes[:'description_html']
      end
      
      if attributes[:'start_date']
        self.start_date = attributes[:'start_date']
      end
      
      if attributes[:'license']
        self.license = attributes[:'license']
      end
      
      if attributes[:'license_other']
        self.license_other = attributes[:'license_other']
      end
      
      if attributes[:'url']
        self.url = attributes[:'url']
      end
      
      if attributes[:'homepage']
        self.homepage = attributes[:'homepage']
      end
      
      if attributes[:'logo_image']
        self.logo_image = attributes[:'logo_image']
      end
      
      if attributes[:'banner_image']
        self.banner_image = attributes[:'banner_image']
      end
      
      if attributes[:'thumbnail_image']
        self.thumbnail_image = attributes[:'thumbnail_image']
      end
      
      if attributes[:'tools']
        self.tools = attributes[:'tools']
      end
      
      if attributes[:'members']
        if (value = attributes[:'members']).is_a?(Array)
          self.members = value
        end
      end
      
    end

    # Check equality by comparing each attribute.
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          name == o.name &&
          display_name == o.display_name &&
          last_update == o.last_update &&
          description == o.description &&
          description_html == o.description_html &&
          start_date == o.start_date &&
          license == o.license &&
          license_other == o.license_other &&
          url == o.url &&
          homepage == o.homepage &&
          logo_image == o.logo_image &&
          banner_image == o.banner_image &&
          thumbnail_image == o.thumbnail_image &&
          tools == o.tools &&
          members == o.members
    end

    # @see the `==` method
    def eql?(o)
      self == o
    end

    # Calculate hash code according to all attributes.
    def hash
      [id, name, display_name, last_update, description, description_html, start_date, license, license_other, url, homepage, logo_image, banner_image, thumbnail_image, tools, members].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = OSDNClient.const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
